package cn.com.infosec.mobile.android.framework.crypto.impl;

import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.pkcs.PKCSObjectIdentifiers;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;
import cn.com.infosec.asn1.x509.SubjectPublicKeyInfo;
import cn.com.infosec.asn1.x509.X509Name;
import cn.com.infosec.mobile.android.framework.crypto.CipherUtil;
import cn.com.infosec.mobile.android.framework.crypto.CryptoException;
import cn.com.infosec.mobile.android.framework.crypto.IHSM;
import cn.com.infosec.mobile.android.framework.crypto.WrapedEncKeyByUser;
import cn.com.infosec.mobile.android.framework.crypto.impl.gm.SM2Impl;
import cn.com.infosec.x509.X509V3CertificateGenerator;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.math.BigInteger;
import java.security.KeyFactory;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.Signature;
import java.security.cert.Certificate;
import java.security.cert.X509Certificate;
import java.security.spec.X509EncodedKeySpec;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;

public class SoftImpl implements IHSM {
   private String alias;
   private Map<String, PrivateKey> priMap;
   private Map<String, PublicKey> pubMap;
   private Map<String, byte[]> SM2priMap;
   private Map<String, PublicKey> SM2pubMap;
   private String[] supportedSymAlg_GM;

   public SoftImpl() {
      SoftImpl var10000 = this;
      SoftImpl var10001 = this;
      SoftImpl var10002 = this;
      SoftImpl var10003 = this;
      SoftImpl var10004 = this;
      super();
      this.alias = "infosec";
      HashMap var1;
      var1 = new HashMap.<init>();
      var10004.priMap = var1;
      var1 = new HashMap.<init>();
      var10003.pubMap = var1;
      var1 = new HashMap.<init>();
      var10002.SM2priMap = var1;
      var1 = new HashMap.<init>();
      var10001.SM2pubMap = var1;
      String[] var2;
      (var2 = new String[1])[0] = "SM4";
      var10000.supportedSymAlg_GM = var2;
   }

   private PrivateKey getRsaPrivateKey(String keyIdx, String SIGNorENC, char[] pwd) {
      if (!this.priMap.containsKey(keyIdx)) {
         File SIGNorENC1;
         File var10000 = SIGNorENC1 = new File;
         var10000.<init>(keyIdx + ".jks");
         if (!var10000.exists()) {
            throw new CryptoException(keyIdx + " NOT found.");
         }

         FileInputStream var4;
         FileInputStream var5 = var4 = new FileInputStream;
         var4.<init>(SIGNorENC1);
         KeyStore var10002 = KeyStore.getInstance("JKS");
         var10002.load(var4, pwd);
         PrivateKey SIGNorENC2 = (PrivateKey)var10002.getKey(this.alias, pwd);
         this.priMap.put(keyIdx, SIGNorENC2);
         var5.close();
      }

      return (PrivateKey)this.priMap.get(keyIdx);
   }

   public void clearCache() {
      this.priMap.clear();
      this.pubMap.clear();
      this.SM2priMap.clear();
      this.SM2pubMap.clear();
   }

   public PublicKey exportPublicKey(String RSAorSM2, String SIGNorENC, String keyIdx, int keyLen, char[] pwd) {
      Exception var10000;
      label337: {
         boolean var10001;
         boolean var68;
         try {
            var68 = "RSA".equalsIgnoreCase(RSAorSM2);
         } catch (Exception var51) {
            var10000 = var51;
            var10001 = false;
            break label337;
         }

         StringBuilder var10002;
         StringBuilder var10003;
         PublicKey var52;
         File RSAorSM21;
         PublicKey RSAorSM23;
         File var69;
         File var70;
         PublicKey var73;
         SoftImpl var75;
         FileInputStream var76;
         FileOutputStream var82;
         PublicKey var84;
         SoftImpl var89;
         PublicKey var94;
         if (var68) {
            label360: {
               try {
                  var68 = this.pubMap.containsKey(keyIdx);
               } catch (Exception var40) {
                  var10000 = var40;
                  var10001 = false;
                  break label360;
               }

               PublicKey keyLen1;
               if (!var68) {
                  try {
                     var69 = new File;
                  } catch (Exception var39) {
                     var10000 = var39;
                     var10001 = false;
                     break label360;
                  }

                  var70 = RSAorSM21 = var69;

                  try {
                     var10002 = new StringBuilder;
                  } catch (Exception var38) {
                     var10000 = var38;
                     var10001 = false;
                     break label360;
                  }

                  var10003 = var10002;

                  try {
                     var10003.<init>();
                     var70.<init>(var10002.append(keyIdx).append(".jks").toString());
                     var68 = var69.exists();
                  } catch (Exception var37) {
                     var10000 = var37;
                     var10001 = false;
                     break label360;
                  }

                  if (var68) {
                     try {
                        var75 = this;
                        var76 = new FileInputStream;
                     } catch (Exception var36) {
                        var10000 = var36;
                        var10001 = false;
                        break label360;
                     }

                     FileInputStream SIGNorENC1 = var76;

                     KeyStore var79;
                     try {
                        var76.<init>(RSAorSM21);
                        var79 = KeyStore.getInstance("JKS");
                     } catch (Exception var35) {
                        var10000 = var35;
                        var10001 = false;
                        break label360;
                     }

                     KeyStore RSAorSM22 = var79;

                     try {
                        RSAorSM22.load(SIGNorENC1, pwd);
                        SIGNorENC1.close();
                        var84 = var79.getCertificate(this.alias).getPublicKey();
                     } catch (Exception var34) {
                        var10000 = var34;
                        var10001 = false;
                        break label360;
                     }

                     var52 = var84;

                     try {
                        var75.pubMap.put(keyIdx, var52);
                     } catch (Exception var33) {
                        var10000 = var33;
                        var10001 = false;
                        break label360;
                     }

                     keyLen1 = var52;
                  } else {
                     KeyPair var72;
                     PrivateKey var74;
                     try {
                        var75 = this;
                        var89 = this;
                        KeyPairGenerator var71 = KeyPairGenerator.getInstance("RSA", "INFOSEC");
                        var71.initialize(keyLen, new SecureRandom());
                        var72 = var71.generateKeyPair();
                        var74 = var72.getPrivate();
                     } catch (Exception var32) {
                        var10000 = var32;
                        var10001 = false;
                        break label360;
                     }

                     PrivateKey SIGNorENC2 = var74;

                     try {
                        var73 = var72.getPublic();
                     } catch (Exception var31) {
                        var10000 = var31;
                        var10001 = false;
                        break label360;
                     }

                     keyLen1 = var73;

                     X509V3CertificateGenerator var77;
                     try {
                        var77 = new X509V3CertificateGenerator;
                     } catch (Exception var30) {
                        var10000 = var30;
                        var10001 = false;
                        break label360;
                     }

                     X509V3CertificateGenerator var6 = var77;

                     X509Certificate var78;
                     try {
                        var6.<init>();
                        var6.setSerialNumber(new BigInteger("1"));
                        var6.setSubjectDN(new X509Name("cn=test"));
                        var6.setIssuerDN(new X509Name("cn=test"));
                        var6.setNotBefore(new Date());
                        var6.setNotAfter(new Date());
                        var6.setPublicKey(keyLen1);
                        var6.setSignatureAlgorithm("SHA1withRSA");
                        var78 = var77.generate(SIGNorENC2);
                     } catch (Exception var29) {
                        var10000 = var29;
                        var10001 = false;
                        break label360;
                     }

                     X509Certificate var67 = var78;

                     KeyStore var81;
                     try {
                        var81 = KeyStore.getInstance("JKS");
                     } catch (Exception var28) {
                        var10000 = var28;
                        var10001 = false;
                        break label360;
                     }

                     KeyStore var7 = var81;

                     try {
                        var7.load((InputStream)null, (char[])null);
                        var81.setKeyEntry(this.alias, SIGNorENC2, pwd, new Certificate[]{var67});
                        var82 = new FileOutputStream;
                     } catch (Exception var27) {
                        var10000 = var27;
                        var10001 = false;
                        break label360;
                     }

                     FileOutputStream var53 = var82;

                     try {
                        var53.<init>(RSAorSM21);
                        var7.store(var53, pwd);
                        var82.close();
                        var89.pubMap.put(keyIdx, keyLen1);
                     } catch (Exception var26) {
                        var10000 = var26;
                        var10001 = false;
                        break label360;
                     }

                     try {
                        var75.priMap.put(keyIdx, SIGNorENC2);
                     } catch (Exception var25) {
                        var10000 = var25;
                        var10001 = false;
                        break label360;
                     }
                  }
               } else {
                  try {
                     var94 = (PublicKey)this.pubMap.get(keyIdx);
                  } catch (Exception var24) {
                     var10000 = var24;
                     var10001 = false;
                     break label360;
                  }

                  keyLen1 = var94;
               }

               RSAorSM23 = keyLen1;
               return RSAorSM23;
            }
         } else {
            label333: {
               try {
                  var68 = "SM2".equalsIgnoreCase(RSAorSM2);
               } catch (Exception var50) {
                  var10000 = var50;
                  var10001 = false;
                  break label333;
               }

               if (var68) {
                  label329: {
                     try {
                        var68 = this.SM2pubMap.containsKey(keyIdx);
                     } catch (Exception var49) {
                        var10000 = var49;
                        var10001 = false;
                        break label329;
                     }

                     if (!var68) {
                        label344: {
                           try {
                              var69 = new File;
                           } catch (Exception var48) {
                              var10000 = var48;
                              var10001 = false;
                              break label344;
                           }

                           var70 = RSAorSM21 = var69;

                           try {
                              var10002 = new StringBuilder;
                           } catch (Exception var47) {
                              var10000 = var47;
                              var10001 = false;
                              break label344;
                           }

                           var10003 = var10002;

                           try {
                              var10003.<init>();
                              var70.<init>(var10002.append(keyIdx).append(".pub").toString());
                              var68 = var69.exists();
                           } catch (Exception var46) {
                              var10000 = var46;
                              var10001 = false;
                              break label344;
                           }

                           byte[] var54;
                           X509EncodedKeySpec RSAorSM24;
                           byte[] var80;
                           if (var68) {
                              label361: {
                                 FileInputStream var86;
                                 try {
                                    var75 = this;
                                    var76 = new FileInputStream;
                                    var86 = var76;
                                    var76.<init>(RSAorSM21);
                                    var80 = new byte[var76.available()];
                                 } catch (Exception var16) {
                                    var10000 = var16;
                                    var10001 = false;
                                    break label361;
                                 }

                                 var54 = var80;

                                 try {
                                    var86.read(var80);
                                 } catch (Exception var15) {
                                    var10000 = var15;
                                    var10001 = false;
                                    break label361;
                                 }

                                 X509EncodedKeySpec var95;
                                 try {
                                    var76.close();
                                    var95 = new X509EncodedKeySpec;
                                 } catch (Exception var14) {
                                    var10000 = var14;
                                    var10001 = false;
                                    break label361;
                                 }

                                 RSAorSM24 = var95;

                                 try {
                                    var95.<init>(var54);
                                    var84 = KeyFactory.getInstance("EC", "INFOSEC").generatePublic(RSAorSM24);
                                 } catch (Exception var13) {
                                    var10000 = var13;
                                    var10001 = false;
                                    break label361;
                                 }

                                 var52 = var84;

                                 try {
                                    var75.SM2pubMap.put(keyIdx, var52);
                                 } catch (Exception var10) {
                                    var10000 = var10;
                                    var10001 = false;
                                    break label361;
                                 }

                                 RSAorSM23 = var52;
                                 return RSAorSM23;
                              }
                           } else {
                              label346: {
                                 char[] var88;
                                 try {
                                    var75 = this;
                                    var89 = this;
                                    var88 = pwd;
                                    var80 = new byte[32];
                                 } catch (Exception var45) {
                                    var10000 = var45;
                                    var10001 = false;
                                    break label346;
                                 }

                                 byte[] var10004 = var54 = var80;

                                 byte[] var10005;
                                 try {
                                    var10005 = new byte[65];
                                 } catch (Exception var44) {
                                    var10000 = var44;
                                    var10001 = false;
                                    break label346;
                                 }

                                 byte[] SIGNorENC3 = var10005;

                                 byte[] var90;
                                 try {
                                    SM2Impl.genKeyPair(var10004, var10005);
                                    var90 = CipherUtil.PBEencrypt(var88, var80);
                                 } catch (Exception var43) {
                                    var10000 = var43;
                                    var10001 = false;
                                    break label346;
                                 }

                                 byte[] keyLen2 = var90;

                                 File var91;
                                 try {
                                    var91 = new File;
                                 } catch (Exception var42) {
                                    var10000 = var42;
                                    var10001 = false;
                                    break label346;
                                 }

                                 File pwd1 = var91;

                                 try {
                                    var10003 = new StringBuilder;
                                 } catch (Exception var41) {
                                    var10000 = var41;
                                    var10001 = false;
                                    break label346;
                                 }

                                 StringBuilder var83 = var10003;

                                 try {
                                    var83.<init>();
                                    var91.<init>(var10003.append(keyIdx).append(".pri").toString());
                                    var82 = new FileOutputStream;
                                 } catch (Exception var23) {
                                    var10000 = var23;
                                    var10001 = false;
                                    break label346;
                                 }

                                 FileOutputStream var87 = var82;
                                 FileOutputStream var85 = var82;

                                 AlgorithmIdentifier var92;
                                 try {
                                    var85.<init>(pwd1);
                                    var87.write(keyLen2);
                                    var82.close();
                                    var92 = new AlgorithmIdentifier;
                                 } catch (Exception var22) {
                                    var10000 = var22;
                                    var10001 = false;
                                    break label346;
                                 }

                                 AlgorithmIdentifier keyLen3 = var92;

                                 try {
                                    var92.<init>(new DERObjectIdentifier("1.2.840.10045.2.1"), new DERObjectIdentifier("1.2.156.10197.1.301"));
                                    var90 = (new SubjectPublicKeyInfo(keyLen3, SIGNorENC3)).getEncoded();
                                 } catch (Exception var21) {
                                    var10000 = var21;
                                    var10001 = false;
                                    break label346;
                                 }

                                 SIGNorENC3 = var90;

                                 try {
                                    var82 = new FileOutputStream;
                                 } catch (Exception var20) {
                                    var10000 = var20;
                                    var10001 = false;
                                    break label346;
                                 }

                                 var87 = var82;
                                 var85 = var82;

                                 X509EncodedKeySpec var93;
                                 try {
                                    var85.<init>(RSAorSM21);
                                    var87.write(SIGNorENC3);
                                    var82.close();
                                    var93 = new X509EncodedKeySpec;
                                 } catch (Exception var19) {
                                    var10000 = var19;
                                    var10001 = false;
                                    break label346;
                                 }

                                 RSAorSM24 = var93;

                                 try {
                                    var93.<init>(SIGNorENC3);
                                    var73 = KeyFactory.getInstance("EC", "INFOSEC").generatePublic(RSAorSM24);
                                 } catch (Exception var18) {
                                    var10000 = var18;
                                    var10001 = false;
                                    break label346;
                                 }

                                 RSAorSM23 = var73;

                                 try {
                                    var89.SM2priMap.put(keyIdx, var54);
                                 } catch (Exception var17) {
                                    var10000 = var17;
                                    var10001 = false;
                                    break label346;
                                 }

                                 try {
                                    var75.SM2pubMap.put(keyIdx, RSAorSM23);
                                    return RSAorSM23;
                                 } catch (Exception var12) {
                                    var10000 = var12;
                                    var10001 = false;
                                 }
                              }
                           }
                        }
                     } else {
                        label362: {
                           try {
                              var94 = (PublicKey)this.SM2pubMap.get(keyIdx);
                           } catch (Exception var11) {
                              var10000 = var11;
                              var10001 = false;
                              break label362;
                           }

                           RSAorSM23 = var94;
                           return RSAorSM23;
                        }
                     }
                  }
               } else {
                  label347: {
                     CryptoException var96;
                     CryptoException var97;
                     try {
                        var97 = new CryptoException;
                        var96 = var97;
                        var10002 = new StringBuilder;
                     } catch (Exception var9) {
                        var10000 = var9;
                        var10001 = false;
                        break label347;
                     }

                     var10003 = var10002;

                     try {
                        var10003.<init>();
                        var96.<init>(var10002.append(RSAorSM2).append(" NOT support.").toString());
                        throw var97;
                     } catch (Exception var8) {
                        var10000 = var8;
                        var10001 = false;
                     }
                  }
               }
            }
         }
      }

      Exception var57 = var10000;
      throw new CryptoException(var57);
   }

   public void init() {
   }

   public void release() {
   }

   public byte[] signSM2(byte[] priKey, PublicKey pubKey, byte[] data, String signAlg, String sm2Id) {
      Exception var10000;
      label69: {
         boolean var10001;
         label70: {
            if (signAlg != null) {
               boolean var16;
               try {
                  var16 = signAlg.equalsIgnoreCase("SM3withSM2");
               } catch (Exception var13) {
                  var10000 = var13;
                  var10001 = false;
                  break label69;
               }

               if (var16) {
                  break label70;
               }

               try {
                  var16 = signAlg.equals("1.2.156.10197.1.501");
               } catch (Exception var12) {
                  var10000 = var12;
                  var10001 = false;
                  break label69;
               }

               if (var16) {
                  break label70;
               }
            }

            CryptoException var17;
            CryptoException var18;
            StringBuilder var10002;
            try {
               var17 = new CryptoException;
               var18 = var17;
               var10002 = new StringBuilder;
            } catch (Exception var11) {
               var10000 = var11;
               var10001 = false;
               break label69;
            }

            StringBuilder var10003 = var10002;

            try {
               var10003.<init>();
               var18.<init>(var10002.append(signAlg).append(" NOT support.").toString());
               throw var17;
            } catch (Exception var10) {
               var10000 = var10;
               var10001 = false;
               break label69;
            }
         }

         byte[] var20;
         label48: {
            if (sm2Id != null) {
               int var19;
               try {
                  var19 = sm2Id.length();
               } catch (Exception var9) {
                  var10000 = var9;
                  var10001 = false;
                  break label69;
               }

               if (var19 > 0) {
                  try {
                     var20 = CipherUtil.SM3WithId(data, sm2Id.getBytes(), pubKey);
                     break label48;
                  } catch (Exception var8) {
                     var10000 = var8;
                     var10001 = false;
                     break label69;
                  }
               }
            }

            try {
               var20 = CipherUtil.hash("SM3", data);
            } catch (Exception var7) {
               var10000 = var7;
               var10001 = false;
               break label69;
            }
         }

         byte[] var14 = var20;

         try {
            return SM2Impl.signHash(var14, priKey);
         } catch (Exception var6) {
            var10000 = var6;
            var10001 = false;
         }
      }

      Exception var15 = var10000;
      throw new CryptoException(var15);
   }

   public byte[] sign(String keyIdx, int keySize, char[] pwd, byte[] data, String signAlg, String sm2Id) {
      byte[] var34;
      label148: {
         Exception var10000;
         label156: {
            boolean var10001;
            boolean var27;
            if (signAlg != null) {
               label154: {
                  try {
                     var27 = signAlg.equalsIgnoreCase("SHA1withRSA");
                  } catch (Exception var23) {
                     var10000 = var23;
                     var10001 = false;
                     break label156;
                  }

                  if (!var27) {
                     try {
                        var27 = signAlg.equalsIgnoreCase(PKCSObjectIdentifiers.sha1WithRSAEncryption.getId());
                     } catch (Exception var22) {
                        var10000 = var22;
                        var10001 = false;
                        break label156;
                     }

                     if (!var27) {
                        try {
                           var27 = signAlg.equalsIgnoreCase("SHA256withRSA");
                        } catch (Exception var21) {
                           var10000 = var21;
                           var10001 = false;
                           break label156;
                        }

                        if (!var27) {
                           try {
                              var27 = signAlg.equalsIgnoreCase(PKCSObjectIdentifiers.sha256WithRSAEncryption.getId());
                           } catch (Exception var20) {
                              var10000 = var20;
                              var10001 = false;
                              break label156;
                           }

                           if (!var27) {
                              break label154;
                           }
                        }
                     }
                  }

                  try {
                     var27 = signAlg.equalsIgnoreCase("SHA256withRSA");
                  } catch (Exception var17) {
                     var10000 = var17;
                     var10001 = false;
                     break label156;
                  }

                  String var31;
                  label113: {
                     if (!var27) {
                        try {
                           var27 = signAlg.equalsIgnoreCase(PKCSObjectIdentifiers.sha256WithRSAEncryption.getId());
                        } catch (Exception var16) {
                           var10000 = var16;
                           var10001 = false;
                           break label156;
                        }

                        if (!var27) {
                           var31 = "SHA1withRSA";
                           break label113;
                        }
                     }

                     var31 = "SHA256withRSA";
                  }

                  Signature var32;
                  try {
                     var32 = Signature.getInstance(var31, "INFOSEC");
                  } catch (Exception var15) {
                     var10000 = var15;
                     var10001 = false;
                     break label156;
                  }

                  Signature var30 = var32;
                  Signature var10002 = var32;

                  try {
                     var10002.initSign(this.getRsaPrivateKey(keyIdx, "SIGN", pwd));
                     var30.update(data);
                     var34 = var32.sign();
                     break label148;
                  } catch (Exception var9) {
                     var10000 = var9;
                     var10001 = false;
                     break label156;
                  }
               }
            }

            if (signAlg != null) {
               label155: {
                  try {
                     var27 = signAlg.equalsIgnoreCase("SM3withSM2");
                  } catch (Exception var19) {
                     var10000 = var19;
                     var10001 = false;
                     break label156;
                  }

                  if (!var27) {
                     try {
                        var27 = signAlg.equals("1.2.156.10197.1.501");
                     } catch (Exception var18) {
                        var10000 = var18;
                        var10001 = false;
                        break label156;
                     }

                     if (!var27) {
                        break label155;
                     }
                  }

                  byte[] keySize1;
                  label102: {
                     if (sm2Id != null) {
                        int var36;
                        try {
                           var36 = sm2Id.length();
                        } catch (Exception var14) {
                           var10000 = var14;
                           var10001 = false;
                           break label156;
                        }

                        if (var36 > 0) {
                           byte[] var28;
                           SoftImpl var33;
                           try {
                              var34 = data;
                              var33 = this;
                              var28 = sm2Id.getBytes();
                           } catch (Exception var13) {
                              var10000 = var13;
                              var10001 = false;
                              break label156;
                           }

                           keySize1 = var28;

                           try {
                              var34 = CipherUtil.SM3WithId(var34, keySize1, var33.exportPublicKey("SM2", "SIGN", keyIdx, 256, pwd));
                              break label102;
                           } catch (Exception var12) {
                              var10000 = var12;
                              var10001 = false;
                              break label156;
                           }
                        }
                     }

                     try {
                        var34 = CipherUtil.hash("SM3", data);
                     } catch (Exception var11) {
                        var10000 = var11;
                        var10001 = false;
                        break label156;
                     }
                  }

                  keySize1 = var34;

                  try {
                     var34 = SM2Impl.signHash(keySize1, this.getSM2PrivateKey(keyIdx, "SIGN", pwd));
                     break label148;
                  } catch (Exception var10) {
                     var10000 = var10;
                     var10001 = false;
                     break label156;
                  }
               }
            }

            StringBuilder var29;
            CryptoException var35;
            CryptoException var37;
            try {
               var37 = new CryptoException;
               var35 = var37;
               var29 = new StringBuilder;
            } catch (Exception var8) {
               var10000 = var8;
               var10001 = false;
               break label156;
            }

            StringBuilder var10003 = var29;

            try {
               var10003.<init>();
               var35.<init>(var29.append(signAlg).append(" NOT support.").toString());
               throw var37;
            } catch (Exception var7) {
               var10000 = var7;
               var10001 = false;
            }
         }

         Exception var25 = var10000;
         throw new CryptoException(var25);
      }

      byte[] var24 = var34;
      return var24;
   }

   public boolean verify(byte[] data, byte[] signature, PublicKey pk, String signAlg, String sm2Id) {
      Exception var10000;
      label201: {
         boolean var35;
         label203: {
            boolean var10001;
            label204: {
               if (signAlg != null) {
                  try {
                     var35 = signAlg.equalsIgnoreCase("SHA1withRSA");
                  } catch (Exception var29) {
                     var10000 = var29;
                     var10001 = false;
                     break label201;
                  }

                  if (var35) {
                     break label204;
                  }

                  try {
                     var35 = signAlg.equalsIgnoreCase(PKCSObjectIdentifiers.sha1WithRSAEncryption.getId());
                  } catch (Exception var28) {
                     var10000 = var28;
                     var10001 = false;
                     break label201;
                  }

                  if (var35) {
                     break label204;
                  }

                  try {
                     var35 = signAlg.equalsIgnoreCase("SHA256withRSA");
                  } catch (Exception var27) {
                     var10000 = var27;
                     var10001 = false;
                     break label201;
                  }

                  if (var35) {
                     break label204;
                  }

                  try {
                     var35 = signAlg.equalsIgnoreCase(PKCSObjectIdentifiers.sha256WithRSAEncryption.getId());
                  } catch (Exception var26) {
                     var10000 = var26;
                     var10001 = false;
                     break label201;
                  }

                  if (var35) {
                     break label204;
                  }

                  try {
                     var35 = signAlg.equalsIgnoreCase("MD5withRSA");
                  } catch (Exception var25) {
                     var10000 = var25;
                     var10001 = false;
                     break label201;
                  }

                  if (var35) {
                     break label204;
                  }

                  try {
                     var35 = signAlg.equalsIgnoreCase(PKCSObjectIdentifiers.md5WithRSAEncryption.getId());
                  } catch (Exception var24) {
                     var10000 = var24;
                     var10001 = false;
                     break label201;
                  }

                  if (var35) {
                     break label204;
                  }

                  try {
                     var35 = signAlg.equals("1.3.14.3.2.3");
                  } catch (Exception var23) {
                     var10000 = var23;
                     var10001 = false;
                     break label201;
                  }

                  if (var35) {
                     break label204;
                  }
               }

               label206: {
                  if (signAlg != null) {
                     try {
                        var35 = signAlg.equalsIgnoreCase("SM3withSM2");
                     } catch (Exception var22) {
                        var10000 = var22;
                        var10001 = false;
                        break label201;
                     }

                     if (var35) {
                        break label206;
                     }
                  }

                  try {
                     var35 = signAlg.equals("1.2.156.10197.1.501");
                  } catch (Exception var21) {
                     var10000 = var21;
                     var10001 = false;
                     break label201;
                  }

                  if (!var35) {
                     StringBuilder var10002;
                     CryptoException var36;
                     CryptoException var37;
                     try {
                        var37 = new CryptoException;
                        var36 = var37;
                        var10002 = new StringBuilder;
                     } catch (Exception var7) {
                        var10000 = var7;
                        var10001 = false;
                        break label201;
                     }

                     StringBuilder var10003 = var10002;

                     try {
                        var10003.<init>();
                        var36.<init>(var10002.append(signAlg).append(" NOT support.").toString());
                        throw var37;
                     } catch (Exception var6) {
                        var10000 = var6;
                        var10001 = false;
                        break label201;
                     }
                  }
               }

               byte[] var39;
               label168: {
                  if (sm2Id != null) {
                     int var38;
                     try {
                        var38 = sm2Id.length();
                     } catch (Exception var11) {
                        var10000 = var11;
                        var10001 = false;
                        break label201;
                     }

                     if (var38 > 0) {
                        try {
                           var39 = CipherUtil.SM3WithId(data, sm2Id.getBytes(), pk);
                           break label168;
                        } catch (Exception var10) {
                           var10000 = var10;
                           var10001 = false;
                           break label201;
                        }
                     }
                  }

                  try {
                     var39 = CipherUtil.hash("SM3", data);
                  } catch (Exception var9) {
                     var10000 = var9;
                     var10001 = false;
                     break label201;
                  }
               }

               byte[] var30 = var39;

               try {
                  var35 = SM2Impl.verifyHash(var30, signature, CipherUtil.sm2PublicKeyToByte(pk));
                  break label203;
               } catch (Exception var8) {
                  var10000 = var8;
                  var10001 = false;
                  break label201;
               }
            }

            String var40 = signAlg;
            String var31 = "SHA1withRSA";

            try {
               var35 = var40.equalsIgnoreCase("SHA256withRSA");
            } catch (Exception var20) {
               var10000 = var20;
               var10001 = false;
               break label201;
            }

            label161: {
               if (!var35) {
                  try {
                     var35 = signAlg.equalsIgnoreCase(PKCSObjectIdentifiers.sha256WithRSAEncryption.getId());
                  } catch (Exception var19) {
                     var10000 = var19;
                     var10001 = false;
                     break label201;
                  }

                  if (!var35) {
                     try {
                        var35 = signAlg.equalsIgnoreCase("SHA1withRSA");
                     } catch (Exception var18) {
                        var10000 = var18;
                        var10001 = false;
                        break label201;
                     }

                     if (!var35) {
                        try {
                           var35 = signAlg.equalsIgnoreCase(PKCSObjectIdentifiers.sha1WithRSAEncryption.getId());
                        } catch (Exception var17) {
                           var10000 = var17;
                           var10001 = false;
                           break label201;
                        }

                        if (!var35) {
                           try {
                              var35 = signAlg.equalsIgnoreCase("MD5withRSA");
                           } catch (Exception var16) {
                              var10000 = var16;
                              var10001 = false;
                              break label201;
                           }

                           if (!var35) {
                              try {
                                 var35 = signAlg.equalsIgnoreCase(PKCSObjectIdentifiers.md5WithRSAEncryption.getId());
                              } catch (Exception var15) {
                                 var10000 = var15;
                                 var10001 = false;
                                 break label201;
                              }

                              if (!var35) {
                                 try {
                                    var35 = signAlg.equals("1.3.14.3.2.3");
                                 } catch (Exception var14) {
                                    var10000 = var14;
                                    var10001 = false;
                                    break label201;
                                 }

                                 if (!var35) {
                                    break label161;
                                 }
                              }
                           }

                           var31 = "MD5withRSA";
                           break label161;
                        }
                     }

                     var31 = "SHA1withRSA";
                     break label161;
                  }
               }

               var31 = "SHA256withRSA";
            }

            Signature var41;
            try {
               var41 = Signature.getInstance(var31, "INFOSEC");
            } catch (Exception var13) {
               var10000 = var13;
               var10001 = false;
               break label201;
            }

            Signature var32 = var41;

            try {
               var32.initVerify(pk);
               var32.update(data);
               var35 = var41.verify(signature);
            } catch (Exception var12) {
               var10000 = var12;
               var10001 = false;
               break label201;
            }
         }

         boolean var34 = var35;
         return var34;
      }

      Exception var33 = var10000;
      throw new CryptoException(var33);
   }

   public byte[] wrapSymKey(String alg, int keyLen, String keyIdx, String RSAorSM2) {
      Exception var10000;
      label90: {
         boolean var10001;
         String var10002;
         String var20;
         SoftImpl var21;
         SecretKey var27;
         try {
            var20 = RSAorSM2;
            var21 = this;
            var10002 = RSAorSM2;
            KeyGenerator var10003 = KeyGenerator.getInstance(alg, "INFOSEC");
            var10003.init(keyLen);
            var27 = var10003.generateKey();
         } catch (Exception var15) {
            var10000 = var15;
            var10001 = false;
            break label90;
         }

         SecretKey var16 = var27;

         PublicKey var23;
         try {
            var23 = var21.exportPublicKey(var10002, "ENC", keyIdx, 0, (char[])null);
         } catch (Exception var14) {
            var10000 = var14;
            var10001 = false;
            break label90;
         }

         label86: {
            byte[] var17;
            byte[] var29;
            label91: {
               PublicKey alg1 = var23;
               boolean var22;
               if (var20 != null) {
                  try {
                     var22 = RSAorSM2.equalsIgnoreCase("RSA");
                  } catch (Exception var13) {
                     var10000 = var13;
                     var10001 = false;
                     break label90;
                  }

                  if (var22) {
                     Cipher var33;
                     try {
                        var33 = Cipher.getInstance("RSA/ECB/PKCS1PADDING");
                     } catch (Exception var11) {
                        var10000 = var11;
                        var10001 = false;
                        break label90;
                     }

                     Cipher var34 = var33;
                     Cipher var25 = var33;

                     try {
                        var25.init(1, alg1);
                        var34.update(var16.getEncoded());
                     } catch (Exception var10) {
                        var10000 = var10;
                        var10001 = false;
                        break label90;
                     }

                     try {
                        var29 = var33.doFinal();
                        break label91;
                     } catch (Exception var9) {
                        var10000 = var9;
                        var10001 = false;
                        break label90;
                     }
                  }
               }

               if (RSAorSM2 == null) {
                  break label86;
               }

               try {
                  var22 = RSAorSM2.equalsIgnoreCase("SM2");
               } catch (Exception var12) {
                  var10000 = var12;
                  var10001 = false;
                  break label90;
               }

               if (!var22) {
                  break label86;
               }

               SecretKey var26;
               byte[] var28;
               try {
                  var26 = var16;
                  var28 = CipherUtil.sm2PublicKeyToByte(alg1);
               } catch (Exception var8) {
                  var10000 = var8;
                  var10001 = false;
                  break label90;
               }

               var17 = var28;

               try {
                  var29 = SM2Impl.encrypt(var26.getEncoded(), var17);
               } catch (Exception var7) {
                  var10000 = var7;
                  var10001 = false;
                  break label90;
               }
            }

            var17 = var29;
            return var17;
         }

         StringBuilder var24;
         CryptoException var31;
         CryptoException var32;
         try {
            var31 = new CryptoException;
            var32 = var31;
            var24 = new StringBuilder;
         } catch (Exception var6) {
            var10000 = var6;
            var10001 = false;
            break label90;
         }

         StringBuilder var30 = var24;

         try {
            var30.<init>();
            var32.<init>(var24.append(RSAorSM2).append(" NOT support.").toString());
            throw var31;
         } catch (Exception var5) {
            var10000 = var5;
            var10001 = false;
         }
      }

      Exception var18 = var10000;
      throw new CryptoException(var18);
   }

   public byte[] getSM2PrivateKey(String keyIdx, String SIGNorENC, char[] pwd) {
      if (!this.SM2priMap.containsKey(keyIdx)) {
         File SIGNorENC1;
         File var10000 = SIGNorENC1 = new File;
         var10000.<init>(keyIdx + ".pri");
         if (!var10000.exists()) {
            throw new CryptoException(keyIdx + " NOT found.");
         }

         FileInputStream var10002 = new FileInputStream(SIGNorENC1);
         byte[] SIGNorENC2;
         var10002.read(SIGNorENC2 = new byte[var10002.available()]);
         var10002.close();
         SIGNorENC2 = CipherUtil.PBEdecrypt(pwd, SIGNorENC2);
         this.SM2priMap.put(keyIdx, SIGNorENC2);
      }

      return (byte[])this.SM2priMap.get(keyIdx);
   }

   public byte[] genKEK(int keyLen, String keyIdx, int keySize, char[] pwd, String RSAorSM2) {
      throw new CryptoException("Not support");
   }

   public byte[][] genEncKeyPair(byte[] encKek, String keyIdx, int keySize, char[] pwd, String wrapAlg, String kekAlg, String userKeyAlg, int keyLen) {
      throw new CryptoException("Not support");
   }

   public WrapedEncKeyByUser wrapPrivKeyByUserPubKey(byte[] wrapedPriv, byte[] encKek, String serverKekAlg, String keyIdx, String RSAorSM2, char[] pwd, PublicKey userPubKey, String usrKekAlg) {
      throw new CryptoException("Not support");
   }

   public byte[] reWrapPrivKeyByKek(String kekAlg, byte[] wrapedPrivKeyByOldKek, byte[] oldKek, byte[] newKek, String keyIdx, int keySize, String RSAorSM2, char[] pwd) {
      throw new CryptoException("Not support");
   }

   public void setSupportedSymAlg_GM(String[] algNames) {
      this.supportedSymAlg_GM = algNames;
   }

   public String[] getSupportedSymAlg_GM() {
      return this.supportedSymAlg_GM;
   }

   public byte[] asymEnc(byte[] plain, PublicKey pk) {
      if ("EC".equals(pk.getAlgorithm())) {
         try {
            return SM2Impl.encrypt(plain, CipherUtil.sm2PublicKeyToByte(pk));
         } catch (Exception var3) {
            throw new CryptoException(var3);
         }
      } else if ("RSA".equals(pk.getAlgorithm())) {
         Exception var10000;
         label43: {
            boolean var10001;
            Cipher var8;
            try {
               var8 = Cipher.getInstance("RSA/ECB/PKCS1PADDING");
            } catch (Exception var6) {
               var10000 = var6;
               var10001 = false;
               break label43;
            }

            Cipher var9 = var8;
            Cipher var10002 = var8;

            try {
               var10002.init(1, pk);
               var9.update(plain);
            } catch (Exception var5) {
               var10000 = var5;
               var10001 = false;
               break label43;
            }

            try {
               return var8.doFinal();
            } catch (Exception var4) {
               var10000 = var4;
               var10001 = false;
            }
         }

         Exception var7 = var10000;
         throw new CryptoException(var7);
      } else {
         throw new CryptoException("public key Alg[" + pk.getAlgorithm() + "] is NOT support");
      }
   }

   public byte[] sm2Decrypt(byte[] cipher, byte[] priKey, String RSAorSM2) {
      if ("SM2".equals(RSAorSM2)) {
         byte[] var10000;
         try {
            var10000 = SM2Impl.decrypt(cipher, priKey);
         } catch (Exception var4) {
            throw new CryptoException(var4);
         }

         byte[] var5 = var10000;
         if (var10000 != null) {
            return var5;
         } else {
            throw new CryptoException("sm2 decryption fail");
         }
      } else {
         throw new CryptoException(RSAorSM2 + " NOT support");
      }
   }

   public byte[] asymDec(byte[] cipher, String keyIdx, String RSAorSM2, char[] pwd) {
      if ("RSA".equals(RSAorSM2)) {
         Exception var13;
         label56: {
            PrivateKey var14;
            boolean var10001;
            try {
               var14 = this.getRsaPrivateKey(keyIdx, "ENC", pwd);
            } catch (Exception var9) {
               var13 = var9;
               var10001 = false;
               break label56;
            }

            PrivateKey var11 = var14;

            Cipher var15;
            try {
               var15 = Cipher.getInstance("RSA/ECB/PKCS1PADDING");
            } catch (Exception var8) {
               var13 = var8;
               var10001 = false;
               break label56;
            }

            Cipher var16 = var15;
            Cipher var10002 = var15;

            try {
               var10002.init(2, var11);
               var16.update(cipher);
            } catch (Exception var7) {
               var13 = var7;
               var10001 = false;
               break label56;
            }

            try {
               return var15.doFinal();
            } catch (Exception var6) {
               var13 = var6;
               var10001 = false;
            }
         }

         Exception var12 = var13;
         throw new CryptoException(var12);
      } else if ("SM2".equals(RSAorSM2)) {
         byte[] var10000;
         try {
            var10000 = SM2Impl.decrypt(cipher, this.getSM2PrivateKey(keyIdx, "ENC", pwd));
         } catch (Exception var5) {
            throw new CryptoException(var5);
         }

         byte[] var10 = var10000;
         if (var10000 != null) {
            return var10;
         } else {
            throw new CryptoException("sm2 decryption fail");
         }
      } else {
         throw new CryptoException(RSAorSM2 + " NOT support");
      }
   }
}
